package wrapper;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import log.CLog;

@SuppressWarnings("rawtypes")
public class GridHttpServletRequest implements HttpServletRequest {

	private HttpServletRequest original;
	String jdgsession = null;
	
	public GridHttpServletRequest(HttpServletRequest original) {
		super();
		this.original = original;
	}

	public Object getAttribute(String arg0) {
		return original.getAttribute(arg0);
	}

	public Enumeration getAttributeNames() {
		return original.getAttributeNames();
	}

	public String getCharacterEncoding() {
		return original.getCharacterEncoding();
	}

	public int getContentLength() {
		return original.getContentLength();
	}

	public String getContentType() {
		return original.getContentType();
	}

	public ServletInputStream getInputStream() throws IOException {
		return original.getInputStream();
	}

	public String getLocalAddr() {
		return original.getLocalAddr();
	}

	public String getLocalName() {
		return original.getLocalName();
	}

	public int getLocalPort() {
		return original.getLocalPort();
	}

	public Locale getLocale() {
		return original.getLocale();
	}

	public Enumeration getLocales() {
		return original.getLocales();
	}

	public String getParameter(String arg0) {
		return original.getParameter(arg0);
	}

	public Map getParameterMap() {
		return original.getParameterMap();
	}

	public Enumeration getParameterNames() {
		return original.getParameterNames();
	}

	public String[] getParameterValues(String arg0) {
		return original.getParameterValues(arg0);
	}

	public String getProtocol() {
		return original.getProtocol();
	}

	public BufferedReader getReader() throws IOException {
		return original.getReader();
	}

	@SuppressWarnings("deprecation")
	public String getRealPath(String arg0) {
		return original.getRealPath(arg0);
	}

	public String getRemoteAddr() {
		return original.getRemoteAddr();
	}

	public String getRemoteHost() {
		return original.getRemoteHost();
	}

	public int getRemotePort() {
		return original.getRemotePort();
	}

	public RequestDispatcher getRequestDispatcher(String arg0) {
		return original.getRequestDispatcher(arg0);
	}

	public String getScheme() {
		return original.getScheme();
	}

	public String getServerName() {
		return original.getServerName();
	}

	public int getServerPort() {
		return original.getServerPort();
	}

	public boolean isSecure() {
		return original.isSecure();
	}

	public void removeAttribute(String arg0) {
		original.removeAttribute(arg0);
	}

	public void setAttribute(String arg0, Object arg1) {
		original.setAttribute(arg0, arg1);
	}

	public void setCharacterEncoding(String arg0)
			throws UnsupportedEncodingException {
		original.setCharacterEncoding(arg0);
	}

	public String getAuthType() {
		return original.getAuthType();
	}

	public String getContextPath() {
		return original.getContentType();
	}

	public Cookie[] getCookies() {
		return original.getCookies();
	}

	public long getDateHeader(String arg0) {
		return original.getDateHeader(arg0);
	}

	public String getHeader(String arg0) {
		return original.getHeader(arg0);
	}

	public Enumeration getHeaderNames() {
		return original.getHeaderNames();
	}

	public Enumeration getHeaders(String arg0) {
		return original.getHeaders(arg0);
	}

	public int getIntHeader(String arg0) {
		return original.getIntHeader(arg0);
	}

	public String getMethod() {
		return original.getMethod();
	}

	public String getPathInfo() {
		return original.getPathInfo();
	}

	public String getPathTranslated() {
		return original.getPathTranslated();
	}

	public String getQueryString() {
		return original.getQueryString();
	}

	public String getRemoteUser() {
		return original.getRemoteUser();
	}

	public String getRequestURI() {
		return original.getRequestURI();
	}

	public StringBuffer getRequestURL() {
		return original.getRequestURL();
	}

	public String getRequestedSessionId() {
		return original.getRequestedSessionId();
	}

	public String getServletPath() {
		return original.getServletPath();
	}

	public HttpSession getSession() {
		
		HttpSession orgSession = original.getSession();
		
		if ( orgSession instanceof GridHttpSession )
			return orgSession;
		
		if (jdgsession == null)
			CLog.debug( this, "jdgsession null...");
		
		GridHttpSession gridSession = new GridHttpSession( orgSession , jdgsession );
		
		return gridSession;
	}

	public HttpSession getSession(boolean arg0) {
		return original.getSession(arg0);
	}

	public Principal getUserPrincipal() {
		return original.getUserPrincipal();
	}

	public boolean isRequestedSessionIdFromCookie() {
		return original.isRequestedSessionIdFromCookie();
	}

	public boolean isRequestedSessionIdFromURL() {
		return original.isRequestedSessionIdFromURL();
	}

	@SuppressWarnings("deprecation")
	public boolean isRequestedSessionIdFromUrl() {
		return original.isRequestedSessionIdFromUrl();
	}

	public boolean isRequestedSessionIdValid() {
		return original.isRequestedSessionIdValid();
	}

	public boolean isUserInRole(String arg0) {
		return original.isUserInRole(arg0);
	}

	public String getJdgsession() {
		return jdgsession;
	}

	public void setJdgsession(String jdgsession) {
		this.jdgsession = jdgsession;
	}

	
	
}
