package wrapper;

import grid.GridAPI;
import grid.GridFactory;

import java.util.ArrayList;
import java.util.Enumeration;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionContext;

import log.CLog;

@SuppressWarnings("deprecation")
public class GridHttpSession implements HttpSession {

	HttpSession original = null;
	GridAPI grid = null;
	String jdgsession = null;
	
	public GridHttpSession(HttpSession original, String jdgsession) {
		super();
		this.original = original;
		grid = GridFactory.getInstance();
		this.jdgsession = jdgsession;
	}

	public Object getAttribute(String arg0) {
		return original.getAttribute(arg0);
	}

	@SuppressWarnings("rawtypes")
	public Enumeration getAttributeNames() {
		return original.getAttributeNames();
	}

	public long getCreationTime() {
		return original.getCreationTime();
	}

	public String getId() {
		return original.getId();
	}

	public long getLastAccessedTime() {
		return original.getLastAccessedTime();
	}

	public int getMaxInactiveInterval() {
		return original.getMaxInactiveInterval();
	}

	public ServletContext getServletContext() {
		return original.getServletContext();
	}

	public HttpSessionContext getSessionContext() {
		return original.getSessionContext();
	}

	public Object getValue(String arg0) {
		return original.getAttribute(arg0);
	}

	public String[] getValueNames() {
		return original.getValueNames();
	}

	public void invalidate() {
		original.invalidate();
	}

	public boolean isNew() {
		return original.isNew();
	}

	public void putValue(String arg0, Object arg1) {
		original.putValue(arg0, arg1);
	}

	public void removeAttribute(String arg0) {
		original.removeAttribute(arg0);
	}

	public void removeValue(String arg0) {
		original.removeValue(arg0);
	}

	public void setAttribute(String arg0, Object arg1) {
		CLog.debug( this, "Catching attributes: (" + arg0 + ", " + arg1.toString() + ") " );
		original.setAttribute(arg0, arg1);
		
		CLog.debug( this, "Updating session in the Grid" );
		grid.updateSessionAttribute(jdgsession, arg0, arg1, original.getAttributeNames());
		
	}

	public void setMaxInactiveInterval(int arg0) {
		original.setMaxInactiveInterval(arg0);
	}

	@SuppressWarnings("rawtypes")
	public void checkAndPopulateSession() {
		Enumeration attributeNames = original.getAttributeNames();
		boolean newLocalSession = ! attributeNames.hasMoreElements();

		if ( newLocalSession && jdgsession != null ) {
			ArrayList<String> oldAttributeNames = grid.getAttributeNames( jdgsession );
			for ( String attributeName : oldAttributeNames ) {
				String gridID = jdgsession + "_" + attributeName;
				Object attributeValue = grid.getAttribute( gridID );
				original.setAttribute( attributeName, attributeValue );
			}
		}
		
	}
	
}
